//////////////////////////////////////////////////////////////
// Struktury obsugi zasilacza
// Copyright (C), Tomasz Fiszer - EVER Sp. z o.o.
//////////////////////////////////////////////////////////////

//Struktura informacyjna
// unsigned char = 1 byte
// unsigned int = 2 bytes
//typedef struct tagUpsInf{
//	unsigned char cSeriaUps;				//1 - SinLine 800 - 2500VA
//	unsigned char cWersjaFirmware;			//wersja firmware w BCD xxxx.xxxx
//	unsigned short iNapiecieWyjsciowe;
//	unsigned short iNapiecieWejsciowe;
//	unsigned short iPradWyjsciowy;
//	unsigned short iCzestotliwoscWejsciowa;
//	unsigned char cNapiecieAkumulatorow;
//	unsigned char cObciazenie;
//	unsigned char cTrybPracy;
//};
#define UPS_INF_COUNT		0x9

#define UPS_SERIES			0x0
#define UPS_FIRMWARE_VER	0x1
#define VOLTAGE_OUTPUT		0x2
#define VOLTAGE_INPUT		0x3
#define CURRENT_OUTPUT		0x4
#define FREQ_INPUT			0x5
#define VOLTAGE_BATTERY		0x6
#define POWER_OUTPUT		0x7
#define UPS_OPERATINGMODE	0x8

#define UPS_SETUP_COUNT		0x2

#define UPS_WORKCONTROL		0x0
#define UPS_STANDBYDELAY	0x1


//definicja bitow rejestru trybu pracy
#define TP_PRACA_STANDBY	0x80 //8
#define TP_ZWARCIE			0x40 //7
#define TP_PRZECIAZENIE		0x20 //6
#define TP_PRACA_BATERYJNA	0x10 //5
#define TP_PRACA_SIECIOWA	0x08 //4
#define TP_AVR				0x04 //3
#define TP_AKU_FULL			0x02 //2
#define TP__				0x01 //1

//Struktura konfiguracyjno kontrolna
//typedef struct tagUpsSetup{
//	unsigned char cKontrolaPracy;
//	unsigned char cUpsStandByDelay;
//};

//definicja bitow rejestru kontroli pracy
#define KP_UPS_STANDBY	0x80 //8
#define KP_UPS_PROGI2	0x40 //7
#define KP_BUZZER		0x20 //6
#define KP_				0x10 //5
#define KP__			0x08 //4
#define KP____			0x04 //3
#define KP______		0x02 //2
#define KP________		0x01 //1

//////////////////////////////////////////////////////////////
